# coding: utf-8

"""
    UbiOps

    Client Library to interact with the UbiOps API.  # noqa: E501

    The version of the OpenAPI document: v2.1
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from ubiops.configuration import Configuration


class AttachmentSourcesList(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'source_name': 'str',
        'mapping': 'list[AttachmentFieldsList]'
    }

    attribute_map = {
        'source_name': 'source_name',
        'mapping': 'mapping'
    }

    def __init__(self, source_name=None, mapping=None, local_vars_configuration=None, **kwargs):  # noqa: E501
        """AttachmentSourcesList - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._source_name = None
        self._mapping = None
        self.discriminator = None

        self.source_name = source_name
        if mapping is not None:
            self.mapping = mapping

    @property
    def source_name(self):
        """Gets the source_name of this AttachmentSourcesList.  # noqa: E501


        :return: The source_name of this AttachmentSourcesList.  # noqa: E501
        :rtype: str
        """
        return self._source_name

    @source_name.setter
    def source_name(self, source_name):
        """Sets the source_name of this AttachmentSourcesList.


        :param source_name: The source_name of this AttachmentSourcesList.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and source_name is None:  # noqa: E501
            raise ValueError("Invalid value for `source_name`, must not be `None`")  # noqa: E501
        if self.local_vars_configuration.client_side_validation and (
            source_name is not None and not isinstance(source_name, str)
        ):
            raise ValueError("Parameter `source_name` must be a string")  # noqa: E501

        if self.local_vars_configuration.client_side_validation and (
            source_name is not None and len(source_name) < 1
        ):
            raise ValueError("Invalid value for `source_name`, length must be greater than or equal to `1`")  # noqa: E501

        self._source_name = source_name

    @property
    def mapping(self):
        """Gets the mapping of this AttachmentSourcesList.  # noqa: E501


        :return: The mapping of this AttachmentSourcesList.  # noqa: E501
        :rtype: list[AttachmentFieldsList]
        """
        return self._mapping

    @mapping.setter
    def mapping(self, mapping):
        """Sets the mapping of this AttachmentSourcesList.


        :param mapping: The mapping of this AttachmentSourcesList.  # noqa: E501
        :type: list[AttachmentFieldsList]
        """
        if self.local_vars_configuration.client_side_validation and (
            mapping is not None and not isinstance(mapping, list)
        ):
            raise ValueError("Parameter `mapping` must be a list")  # noqa: E501
        if self.local_vars_configuration.client_side_validation and mapping is not None:
            from ubiops.models.attachment_fields_list import AttachmentFieldsList

            mapping = [
                AttachmentFieldsList(**item) if isinstance(item, dict) else item  # noqa: E501
                for item in mapping
            ]

        self._mapping = mapping

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AttachmentSourcesList):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AttachmentSourcesList):
            return True

        return self.to_dict() != other.to_dict()
